/******************************************************
* File: TestService.java
* created 31.03.2001 17:22:07 by Administrator
*/
package harvestgui.scripts;
import harvestgui.*;
import java.util.*;

import javax.swing.*;
import java.io.*;
import de.netcomputing.anyj.scripting.*;

public class CCCGet extends AJExternalService
{ 
    
    boolean browse = true; // browse
    boolean syncronize = false; // browse
    static String pack = "EMPTY";
    static String proj;
    
    
    public static String[] FindAJHarvestSigFile( File f )
    {
        if ( f.getAbsolutePath().length() < 4 ) // volume e.g. c:\
            return null;
        if ( f.isDirectory() )
        {
            File sig = new File( f.getParentFile(), "ajharvest.txt" );
            if ( sig.exists() )
            {
                try {
                    FileInputStream in = new FileInputStream( sig );
                    DataInputStream din = new DataInputStream( in );
                    String pack = din.readLine();
                    String repos = din.readLine();
                    in.close();
                    return new String[] { repos, pack };
                } catch ( Exception ex ) {
                    ex.printStackTrace();
                }
            } else
                return FindAJHarvestSigFile( f.getParentFile() );
        } else
            return FindAJHarvestSigFile( f.getParentFile() );
        return null;
    }
    
    public CCCGet() {
        this( true, false );
    }
    
    public CCCGet( boolean browse, boolean syncronize ) {
        super();
        this.browse = browse;
    }
    
    
    static boolean IsRunning;
    
    public boolean canProcessSelection( Object selection )
    {
        if( selection != null )
        {
            if ( selection instanceof File && ! IsRunning )
            {
                File cur = (File)selection;
                String curS = cur.getAbsolutePath();
                if ( curS.toLowerCase().startsWith( (""+AnyJAPI.This().getEnvironment().get("ccch_localroot")).toLowerCase() ) )
                {
                    return true;  
                }
            }
        }
        return false;
    }
    
    Object lastSel;
    String outName = "";
    public void doProcess( Object selection )
    {
        IsRunning = true;
        lastSel = selection;
        outName = "";
        (new Thread() { public void run() {
                    try {
                        // check the environment is set up
                        Hashtable ht = AnyJAPI.This().getEnvironment();
                        if ( ht.get( "ccch_user" ) == null ||
                            ht.get( "ccch_pwd" ) == null ||
                            ht.get( "ccch_repository" ) == null ||
                            ht.get( "ccch_project" ) == null ||
                            ht.get( "ccch_localroot" ) == null )
                        {
                            JOptionPane.showMessageDialog( AnyJAPI.This().getMainWindow(), new String[] {
                                    "Please specify:",
                                    "ccch_user (e.g. moelrue)",
                                    "ccch_pwd (e.g. tryst)",
                                    "ccch_repository (e.g. xeomoon/XE)",
                                    "ccch_project (e.g. XAPI)",
                                    "ccch_localroot  (e.g. d:\\work\\dev\\cccharvest)",
                                    "in AnyJ's user environment"
                                });
                        } else {
                            File dir = (File)lastSel;
                            String fiName;
                            if ( dir.isDirectory() )
                            {
                                fiName = "*";
                            }
                            else
                            {
                                fiName = dir.getName();
                                dir = dir.getParentFile();
                            }
                            try {
                                dir = dir.getCanonicalFile();
                            } catch ( Exception ex ) {
                                ex.printStackTrace();
                            }
                            String reposRoot = dir.getAbsolutePath().substring((""+AnyJAPI.This().getEnvironment().get("ccch_localroot")).length());
                            String cline = "";
                            outName = "CCC GET FOR BROWSE";
                            
                            String proj = CCCGet.proj;
                            if ( proj == null )
                                proj = (String)AnyJAPI.This().getEnvironment().get("ccch_project");
                            if ( proj == null )
                                proj = (String)AnyJAPI.This().getEnvironment().get("ccch_project");
                            String[] projPack = FindAJHarvestSigFile( dir );
                            if ( projPack != null )
                            {
                                proj = projPack[0];
                                pack = projPack[1];
                            }
                            CheckOut res = CheckOut.ShowCheckOutPanel(
                                AnyJAPI.This().getMainWindow(), 
                                browse ? ( syncronize ? "Synchronize" :"Get" ) : "Check Out",
                                proj,
                                pack,
                                fiName
                            );
                            if ( res == null )
                            {
                                IsRunning = false;
                                return;
                            }
                            else
                                pack = res.getPackage();
                            proj = res.getProject().trim();
                            CCCGet.pack = pack;
                            CCCGet.proj = proj;
                            
                            if ( browse )
                            {
                                cline = 
                                "hco -vp "+reposRoot + " -r -cp "+dir.getAbsolutePath()+ 
                                " -b "+AnyJAPI.This().getEnvironment().get("ccch_repository") +
                                " -usr "+AnyJAPI.This().getEnvironment().get("ccch_user")+
                                " -pw " +AnyJAPI.This().getEnvironment().get("ccch_pwd")+
                                " -o " + dir.getAbsolutePath()+File.separator+"hco.log" +
                                (syncronize ? " -sy ":" -br ")+" -en "+proj+
                                " -st \"Implementation Phase\" -pn \"Check Out for Browse (Get)\""+" -s "+fiName;
                                    AnyJAPI.This().getOrCreateOutputPanel( outName ).printLine( "" );
                                AnyJAPI.This().getOrCreateOutputPanel( outName ).printLine( cline );
                                
                                CCCTool.LogReader reader = new CCCTool.LogReader(dir.getAbsolutePath()+File.separator+"hco.log" ,outName  );
                                reader.setRunning( true);
                                reader.start();
                                
                                AnyJAPI.This().executeExternalProcess( outName, File.separator, cline );
                                reader.setRunning(false);
                                if( dir.isDirectory() )
                                {
                                    CCCTool.checkDeletedFileList( outName, ""+dir,false ); 
                                }
                            } else {
                                outName = "CCC CHECKOUT";
                                cline = 
                                "hco -up -vp "+reposRoot+" -r -cp "+dir.getAbsolutePath()+
                                " -b "+AnyJAPI.This().getEnvironment().get("ccch_repository") +
                                " -usr "+AnyJAPI.This().getEnvironment().get("ccch_user")+
                                " -pw " +AnyJAPI.This().getEnvironment().get("ccch_pwd")+
                                " -o " + dir.getAbsolutePath()+File.separator+"hco.log" +
                                " -en "+proj+" -st \"Implementation Phase\" -pn \"Check Out\""
                                +" -p "+pack+" -s "+fiName;
                                AnyJAPI.This().getOrCreateOutputPanel( outName ).printLine( "" );
                                AnyJAPI.This().getOrCreateOutputPanel( outName ).printLine( cline );
                                
                                CCCTool.LogReader reader = new CCCTool.LogReader(dir.getAbsolutePath()+File.separator+"hco.log" ,outName);
                                reader.setRunning( true);
                                reader.start();
                                
                                AnyJAPI.This().executeExternalProcess( outName, File.separator, cline );
                                reader.setRunning(false);
                            }
                        }
                    } finally {
                        IsRunning = false;
                    }
                }
            
            }).start();
    }

}